unit UFPuntuales;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;

  procedure FP_Negativo  ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Grises    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Logaritmo ( Ma : Mat3d; var Mb : Mat3d);
  procedure FP_Gamma     ( Ma : Mat3d; var Mb : Mat3d; gg: single);


implementation

  // Negativo
  procedure FP_Negativo( Ma : Mat3d; var Mb : Mat3d);
  var
    nx,ny, x,y,can : integer;

  begin
    nx := Ma.nc;
    ny := Ma.nr;
    SetMat(Mb,nx,ny,3);

    for y := 0 to ny - 1 do
      for x := 0 to nx - 1 do
        // ---
        for can := 0 to 2 do
          Mb.dat[x][y][can] := _Lamb - Ma.dat[x][y][can];
        // ---

  end;

  // Grises
  procedure FP_Grises( Ma : Mat3d; var Mb : Mat3d);
  var
    nx,ny, x,y,can : integer;
    suma           : single;
  begin
    nx := Ma.nc;
    ny := Ma.nr;
    SetMat(Mb,nx,ny,3);

    for y := 0 to ny - 1 do
      for x := 0 to nx - 1 do begin
        // ---
        suma := 0.0;
        for can := 0 to 2 do suma := suma + Ma.dat[x][y][can];
        suma := suma/3;
        for can := 0 to 2 do Mb.dat[x][y][can] := suma;
        // ---
      end;
  end;

  // LOgaritmo o Rango Dinamico
  procedure FP_Logaritmo ( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can,
    nx,ny     : integer;
    fact      : single;
  begin
    nx := Ma.nc;
    ny := Ma.nr;
    SetMat(Mb,nx,ny,3);

    fact := _Lamb/(ln(_Lamb+1));

    for y := 0 to ny - 1 do
      for x := 0 to nx - 1 do begin
        // ---
        for can := 0 to 2 do
          Mb.dat[x][y][can] :=  fact*ln(Ma.dat[x][y][can]+1);
        // ---
      end;
  end;

  // Filtro o Correccion Gamma
  procedure FP_Gamma     ( Ma : Mat3d; var Mb : Mat3d; gg: single);
  var
    x,y,can,
    nx,ny     : integer;
  begin
    nx := Ma.nc;
    ny := Ma.nr;
    SetMat(Mb,nx,ny,3);

    for y := 0 to ny - 1 do
      for x := 0 to nx - 1 do begin
        // ---
        for can := 0 to 2 do
          Mb.dat[x][y][can] :=  _Lamb*power(Ma.dat[x][y][can]/_Lamb,gg);
        // ---
      end;
  end;
end.
